-------------------------------------------------------------------------
-- Joseph Zambreno
-- Department of Electrical and Computer Engineering
-- Iowa State University
-------------------------------------------------------------------------


-- AESround.vhd
-------------------------------------------------------------------------
-- DESCRIPTION: This file contains the the intra-round layout for the
-- AES encryption design.  Note: check AES_config.vhd first before
-- attempting to modify this file.
--
--
-- NOTES:
-- 10/20/06 by JAZ::Design created.
-------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use WORK.AESencrypt_config.all;

entity AESround is

  port(CLK             	: in std_logic;
       STATE_IN		: in STATEtype;
       KEY_IN           : in KEYtype;
       STATE_OUT        : out STATEtype);
       
end AESround;

architecture dataflow of AESround is

  component SubBytes
    port (STATE_IN      : in STATEtype;
          STATE_OUT     : out STATEtype);
  end component;
    
  component MixColumns
    port (STATE_IN      : in STATEtype;
          STATE_OUT     : out STATEtype);
  end component;
  
  component AddRoundKey
    port (STATE_IN      : in STATEtype;
          KEY_IN        : in KEYtype;
          STATE_OUT     : out STATEtype);
  end component;

  signal B_STATE        : STATEtype_vector(2 downto 0);
  signal M_STATE        : STATEtype_vector(1 downto 0);
  signal E_STATE        : STATEtype_vector(1 downto 0);
begin	

end dataflow;	    











